import numpy as np
import utils as utils
import matplotlib.pyplot as pyplot

class Data(object):
    def __init__(self, num_cells,directory=""):
        self.directory=directory
        """
        Data handling
        """
        self.e_p =np.array([0.00 for i in range(num_cells)])
        """
        Re-init every iteration
        """
        self.New_iteration()
     
        """
        Re-init every step
        """   
        self.New_step()
        self.APS_values=[]      
        self.area_approx=[]
        
    def New_iteration(self):
        self.max_stress  =0.0
        self.max_strain  =0.0
        self.max_strain_p=0.0
        
        self.max_sigma=np.matrix([[0.0] for i in range(6)])        
        self.max_epsilon=np.matrix([[0.0] for i in range(6)])
        self.max_epsilon_p=np.matrix([[0.0] for i in range(6)])
    
        pass
    
    def New_step(self):        
        self.max_array_strain=[]
        self.max_array_stress=[]
        self.max_array_strain_p=[]  
        self.max_array_sigma=[]
        self.max_array_epsilon=[]
        self.max_array_epsilon_p=[]  
        
        pass
    
    
    
    def MaxValues(self, stress , strain ,strain_p):
        temp=utils.equivalentStress(stress)
        if temp > self.max_stress:
            self.max_stress=temp
            self.max_sigma=stress
            self.max_strain=utils.equivalentStrain(strain)
            self.max_epsilon=strain
            self.max_strain_p=utils.equivalentStrain(strain_p)     
            self.max_epsilon_p=strain_p
            
        pass
    
    def AddAPS(self): 
        self.APS_values.append(max(self.e_p))
        
    def StoreAPS(self):
        np.savetxt(self.directory+"/APS.txt",self.APS_values)
        
    def AddValues(self):
        self.max_array_strain.append(self.max_strain)
        self.max_array_strain_p.append(self.max_strain_p)
        self.max_array_stress.append(self.max_stress)
        self.max_array_sigma.append(self.max_sigma)
        self.max_array_epsilon.append(self.max_epsilon)
        self.max_array_epsilon_p.append(self.max_epsilon_p)  
        pass
        
    def Plot(self,num_step):
        pyplot.plot(self.max_array_strain,self.max_array_stress)
        pyplot.savefig(self.directory+"/StressStrain"+str(num_step)+".png")
        pyplot.clf()
        pyplot.plot(self.max_array_strain,self.max_array_strain_p)
        pyplot.savefig(self.directory+"/StrainpStrain"+str(num_step)+".png")
        pyplot.clf()
        pass
    
    def StoreValues(self,num_step):
        np.savetxt(self.directory+"/MaxStress"+str(num_step)+".txt",self.max_array_stress)
        np.savetxt(self.directory+"/MaxplasticStrain"+str(num_step)+".txt",self.max_array_strain_p)
        np.savetxt(self.directory+"/MaxStrain"+str(num_step)+".txt",self.max_array_strain)
        np.savetxt(self.directory+"/MaxStressTensor"+str(num_step)+".txt",self.max_array_sigma)
        np.savetxt(self.directory+"/MaxplasticStrainTensor"+str(num_step)+".txt",self.max_array_epsilon_p)
        np.savetxt(self.directory+"/MaxStrainTensor"+str(num_step)+".txt",self.max_array_epsilon)
        pass
   
    def StoreApproxArea(self):
        np.savetxt(self.directory+"/ApproxArea"+".txt",self.area_approx)
        pass

    def StoreGenereal(self,Settings,num_points,Area,Nodes):
        f=open(self.directory+"/General.txt ",'w')
        for  key, value in Settings.items():
            f.writelines(str(key)+":"+str(value)+"\n")
        f.writelines("Num points :" +str(num_points)+"\n")
        f.writelines("Area:"+str(Area)+"\n")
        f.writelines("Num nodes :" +str(Nodes)+"\n")
        f.close()
        pass
    def StoreSteps(self,steps):
        f=open(self.directory+"/Steps.txt ",'w')
        for  step in steps:
            f.writelines(str(step)+"\n")
        f.close()
        pass