# -*- coding: utf-8 -*-
"""
Created on Mon Apr  7 20:02:24 2014

@author: lars
"""

import numpy as np

class PlasticModel(object):#P i.e  ddg_ddsigma
    def __init__(self,E,nu,yield_stress,work_hardening):
        """
           Must parameters
        """
        mu=E/(2*(1 + nu))
        lmbda=E*nu/((1 + nu)*(1 - 2*nu))
    
        self.elastic_tangent= np.matrix([[ (lmbda+mu*int(i==j))*int(j<3 and i<3)+mu*int(i==j)   for i in range(6)] for j in range(6) ])
        self.yield_stress=yield_stress  
        self.H=work_hardening

        """
           Optinal parameters
        """              
        self.P=np.matrix([[ float(i==j) -(1/3.0)*int(j<3 and i<3) + float(i==j and j>2 and i>2) for i in range(6)] for j in range(6)])
    
        
    def f (self,sigma,e_p):
        return 0.5*sigma.T*self.P*sigma - (( self.yield_stress + self.H*e_p)**2)/3.0
    
    def df(self,sigma):
        return self.P*sigma
    
    def dg(self,sigma):    
        return self.P*sigma
    
    def ddg(self,sigma):
        return self.P
    
    def hardening(self,stress,e_p):
        return 2.0/3.0*(self.yield_stress+self.H*e_p)*self.H*np.sqrt(2.0/3.0*self.dg(stress).T*self.dg(stress))
        
    def APS(self, sigma,delta_lambda,e_p):
        return e_p + delta_lambda*np.sqrt(2.0/3.0*self.dg(sigma).T*self.dg(sigma))

    
    def return_list(self):
        return list(np.asarray(self.elastic_tangent).reshape(-1))
        
        
