from dolfin import *
import math

class Top(SubDomain):
     def __init__(self,tol,**kwargs):
         SubDomain.__init__(self)
         self.tol=tol
         self.height=kwargs.get("height")
     def inside(self,x,on_boundary):
		return near(self.height,x[2],self.tol) 
	
class Bottom(SubDomain):
     def __init__(self,tol,**kwargs):
         SubDomain.__init__(self)
         self.tol=tol
         self.base=kwargs.get("base")
     def inside(self,x,on_boundary):
		return near(x[2],self.base,self.tol)


class Outer(SubDomain):
     def __init__(self,tol,**kwargs):
         SubDomain.__init__(self)
         self.tol=tol
         self.outer_radi=kwargs.get("outer_radi")
     def inside(self,x,on_boundary):
		r = math.sqrt( x[0]*x[0]+x[1]*x[1])
		return near(r,self.outer_radi,self.tol) 

class Inner(SubDomain):
     def __init__(self,tol,**kwargs):
         SubDomain.__init__(self)
         self.tol=tol
         self.inner_radi=kwargs.get("inner_radi")
     def inside(self,x,on_boundary):
		r = math.sqrt( x[0]*x[0]+x[1]*x[1])
		return near(r,self.inner_radi,self.tol) 